=== debian/changelog ===
gudhi (3.2.0+dfsg-4) unstable; urgency=medium

  * Re-enable build-time tests on s390x, no longer failing.
  * Simplify autopkgtesting.
  * Demote matplotlib and POT to recommends for python3-gudhi.
  * Demote libhera-dev to suggests for libgudhi-dev.

 -- Gard Spreemann <gspr@nonempty.org>  Fri, 10 Jul 2020 11:14:03 +0200

gudhi (3.2.0+dfsg-3) unstable; urgency=medium

  * Enable Wasserstein Python module. (Closes: #949475)
    - Depend on python3-pot.
    - Drop corresponding patch.
    - Don't blacklist Wasserstein tests anymore.
  * Recommend POT, SciPy and scikit-learn.

 -- Gard Spreemann <gspr@nonempty.org>  Wed, 08 Jul 2020 21:32:32 +0200

gudhi (3.2.0+dfsg-2) unstable; urgency=medium

  * Add patch 0010-Work-around-963955.patch to work around FTBFS with
    Qt 5.14.
  * DH compat level 13.

 -- Gard Spreemann <gspr@nonempty.org>  Mon, 29 Jun 2020 13:40:18 +0200

gudhi (3.2.0+dfsg-1) unstable; urgency=medium

  * New upstream release. (Closes: #961783)
  * Refresh patches.
  * Depend on pybind11 and hera.
  * Fix broken tests that trivially passed.

 -- Gard Spreemann <gspr@nonempty.org>  Sat, 06 Jun 2020 15:12:31 +0200
