=== debian/tests/control ===
Tests: python-upstream.sh
Depends: python3-all, python3-gudhi, python3-matplotlib, python3-pot, python3-pytest, python3-scipy, python3-sklearn, python3-tk
Restrictions: allow-stderr
